/*------------------------------------------------------------------------
    File        : binary_data.p
    Purpose     : 

    Syntax      :

    Description : 

    Author(s)   : 
    Created     : Mon Jun 08 10:11:37 EDT 2015
    Notes       :
  ----------------------------------------------------------------------*/
block-level on error undo, throw.

block-level on error undo, throw.

using OpenEdge.Core.Assert.
using OpenEdge.Core.ByteBucket.
using OpenEdge.Core.Memptr.
using OpenEdge.Core.WidgetHandle.
using OpenEdge.Net.HTTP.ClientBuilder.
using OpenEdge.Net.HTTP.IHttpClient.
using OpenEdge.Net.HTTP.IHttpRequest.
using OpenEdge.Net.HTTP.IHttpResponse.
using OpenEdge.Net.HTTP.RequestBuilder.
using Progress.Json.ObjectModel.JsonObject.
using Progress.Lang.Object.
using OpenEdge.Net.HTTP.StatusCodeEnum.

    define variable moHttpClient as IHttpClient no-undo.
          
    moHttpClient  = ClientBuilder:Build():Client.
    
    run GetImage.

    procedure GetImage:
        define variable oReq as IHttpRequest no-undo.
        define variable oResp as IHttpResponse no-undo.
        define variable oEntity as Object no-undo.
        define variable oImage as class Memptr no-undo.            
        
        oReq = RequestBuilder:Get('http://httpbin.org/image/png')
                   :Request.

        oResp = moHttpClient:Execute(oReq).
        
        message 
        oResp:StatusCode skip
        oResp:ContentType skip
        oResp:ContentLength skip
        view-as alert-box.
        
        oImage = cast(oResp:Entity, Memptr).
        
        copy-lob oImage:Value to file session:temp-dir + 'image.png'.

                
    end procedure.     
