/*------------------------------------------------------------------------
    File        : marvel.p
    Purpose     : 

    Syntax      :

    Description : 

    Author(s)   : 
    Created     : Sun Jun 07 16:18:48 EDT 2015
    Notes       :
  ----------------------------------------------------------------------*/
block-level on error undo, throw.

using OpenEdge.Core.Memptr.
using OpenEdge.Net.HTTP.ClientBuilder.
using OpenEdge.Net.HTTP.IHttpClient.
using OpenEdge.Net.HTTP.IHttpRequest.
using OpenEdge.Net.HTTP.IHttpResponse.
using OpenEdge.Net.HTTP.RequestBuilder.
using OpenEdge.Net.URI.
using Progress.Json.ObjectModel.JsonArray.
using Progress.Json.ObjectModel.JsonObject.

/* ********************  Preprocessor Definitions  ******************** */
define variable oKeys as JsonObject no-undo.
define variable cTS as character no-undo.
define variable cTsHash as character no-undo.
define variable oURI as URI no-undo.
define variable oReq as IHttpRequest no-undo.
define variable oResp as IHttpResponse no-undo.
define variable oClient as IHttpClient no-undo.
define variable oData as JsonObject no-undo. 
define variable iLength as integer no-undo.
define variable oAll as JsonArray no-undo.
define variable oImageJson as JsonObject no-undo.
define variable oImage as class Memptr no-undo.
define variable iLoop as integer no-undo.

/* ***************************  Main Block  *************************** */
oClient = ClientBuilder:Build():Client.

oURI = new URI('http', 'gateway.marvel.com').

oURI:Path = '/v1/public/characters'.
oURI:AddQuery('apikey', 'a6917b4d3080bdd98f6717bb03874fc8').
oURI:AddQuery('ts', 'aaabbcc').
oURI:AddQuery('hash', '4d015f4b611dee707d42e02b9a1c07b8').

oURI:AddQuery('name', 'Hulk').
/*oURI:AddQuery('nameStartsWith', 'Nick').*/

oReq = RequestBuilder:Get(oURI)
            :AcceptJson()
            :Request.
            
oResp = oClient:Execute(oReq).             

message 
oResp:StatusCode skip
oResp:ContentType
view-as alert-box.

oData = cast(oResp:Entity, JsonObject).
oData:WriteFile(session:temp-dir + '/hulk.json', true).

/* eof */











